package assimp

import glm_.mat4x4.Mat4
import glm_.vec3.Vec3
import io.kotlintest.matchers.shouldBe
import io.kotlintest.specs.StringSpec
import java.util.*

/**
 * Created by elect on 16/11/2016.
 */

class obj : StringSpec() {

    val obj = models + "/OBJ/"

    init {

//        val dragon = "dragon/dragon.obj"
//
//        dragon {
//
//            with(Importer().readFile(obj + dragon)!!) {
//
//                println()
////                with(rootNode) {
////
////                    name shouldBe "nanosuit.obj"
////                    transformation shouldBe Mat4()
////                    numChildren shouldBe 7
////
////                    val names = listOf("Visor", "Legs", "hands", "Lights", "Arms", "Helmet", "Body")
////
////                    (0 until numChildren).map {
////                        children[it].name shouldBe names[it]
////                        children[it].meshes!![0] shouldBe it
////                    }
////
////                    numMeshes shouldBe 0
////                }
//            }
//        }

        val nanosuit = "nanosuit/nanosuit.obj"

        nanosuit {

            with(Importer().readFile(obj + nanosuit)!!) {

                with(rootNode) {

                    name shouldBe "nanosuit.obj"
                    transformation shouldBe Mat4()
                    numChildren shouldBe 7

                    val names = listOf("Visor", "Legs", "hands", "Lights", "Arms", "Helmet", "Body")

                    (0 until numChildren).map {
                        children[it].name shouldBe names[it]
                        children[it].meshes[0] shouldBe it
                    }

                    numMeshes shouldBe 0
                }

                with(meshes[0]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 156
                    numFaces shouldBe 52

                    vertices[0] shouldBe Vec3(x = 0.320383996f, y = 14.0575409f, z = 0.507779002)
                    vertices[77] shouldBe Vec3(x = 0.00970300008f, y = 14.3252335f, z = 0.651058972)
                    vertices[numVertices - 1] shouldBe Vec3(x = -0.300857008f, y = 14.0575409f, z = 0.507779002f)

                    normals[0] shouldBe Vec3(x = 0.496899992f, y = -0.240799993f, z = 0.833700001)
                    normals[77] shouldBe Vec3(x = 0.108800001f, y = -0.159199998f, z = 0.981199980f)
                    normals[numVertices - 1] shouldBe Vec3(x = -0.496399999f, y = -0.241899997f, z = 0.833700001f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.439940989f, 0.453613013f)) shouldBe true
                    Arrays.equals(textureCoords[0][77], floatArrayOf(0.0595699996f, 0.754760981f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.439940989f, 0.453613013f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[25] shouldBe listOf(75, 76, 77)
                    faces[numFaces - 1] shouldBe listOf(153, 154, 155)

                    materialIndex shouldBe 3

                    name shouldBe "Visor"
                }

                with(meshes[1]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 15222
                    numFaces shouldBe 5074

                    vertices[0] shouldBe Vec3(x = 1.899165f, y = 2.31763411f, z = -0.120600000f)
                    vertices[7610] shouldBe Vec3(x = -0.425206006f, y = 6.15252495f, z = 0.327194005f)
                    vertices[numVertices - 1] shouldBe Vec3(x = 0.602433026f, y = 7.82357216f, z = -1.3782050f)

                    normals[0] shouldBe Vec3(x = -0.710300028f, y = 0.137300000f, z = 0.690400004)
                    normals[7610] shouldBe Vec3(x = 0.849799991f, y = -0.326099992f, z = 0.414099991f)
                    normals[numVertices - 1] shouldBe Vec3(x = 0.0302000009f, y = -0.153899997f, z = -0.987600029f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.283690989f, 0.568114996f)) shouldBe true
                    Arrays.equals(textureCoords[0][7610], floatArrayOf(1.9658200f, 0.282715f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.373046994f, 0.152344003f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[2536] shouldBe listOf(7608, 7609, 7610)
                    faces[numFaces - 1] shouldBe listOf(15219, 15220, 15221)

                    materialIndex shouldBe 6

                    name shouldBe "Legs"
                }

                with(meshes[2]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 19350
                    numFaces shouldBe 6450

                    vertices[0] shouldBe Vec3(x = -3.55469608f, y = 8.31433487f, z = 1.45077002)
                    vertices[9675] shouldBe Vec3(x = 3.56796789f, y = 7.70999908f, z = 1.54873502f)
                    vertices[numVertices - 1] shouldBe Vec3(x = 3.46042705f, y = 7.47475290f, z = 1.01681304f)

                    normals[0] shouldBe Vec3(x = -0.408199996f, y = -0.825800002f, z = -0.389200002f)
                    normals[9675] shouldBe Vec3(x = 0.930800021f, y = -0.305799991f, z = 0.200299993f)
                    normals[numVertices - 1] shouldBe Vec3(x = 0.365900010f, y = 0.658500016f, z = -0.657599986f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.948729992f, 0.610351980f)) shouldBe true
                    Arrays.equals(textureCoords[0][9675], floatArrayOf(0.949218988f, 0.799315989f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.321045011f, 0.451660007f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[2536] shouldBe listOf(7608, 7609, 7610)
                    faces[numFaces - 1] shouldBe listOf(19347, 19348, 19349)

                    materialIndex shouldBe 4

                    name shouldBe "hands"
                }

                with(meshes[3]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 78
                    numFaces shouldBe 26

                    vertices[0] shouldBe Vec3(x = 0.519383013f, y = 14.0981007f, z = 0.399747014f)
                    vertices[numVertices - 1] shouldBe Vec3(x = -0.454726994f, y = 14.0737648f, z = 0.435452998f)

                    normals[0] shouldBe Vec3(x = 0.663699985f, y = -0.158099994f, z = 0.731100023)
                    normals[numVertices - 1] shouldBe Vec3(x = -0.663699985f, y = -0.158099994f, z = 0.731100023f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.470214993f, 0.796020985f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.148314998f, 0.648193002f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(75, 76, 77)

                    materialIndex shouldBe 3

                    name shouldBe "Lights"
                }

                with(meshes[4]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 6804
                    numFaces shouldBe 2268

                    vertices[0] shouldBe Vec3(x = 3.65801501f, y = 9.13363171f, z = 1.10836804f)
                    vertices[numVertices - 1] shouldBe Vec3(x = 3.06237602f, y = 10.2043982f, z = -0.735961020f)

                    normals[0] shouldBe Vec3(x = -0.949199975f, y = -0.0269000009f, z = -0.313499987f)
                    normals[numVertices - 1] shouldBe Vec3(x = 0.365000010f, y = -0.602299988f, z = -0.709900022f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.451171994f, 0.0678709969f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.772948980f, 0.980515003f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(6801, 6802, 6803)

                    materialIndex shouldBe 1

                    name shouldBe "Arms"
                }

                with(meshes[5]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 7248
                    numFaces shouldBe 2416

                    vertices[0] shouldBe Vec3(x = 0.169514000f, y = 13.7492905f, z = 0.552182019f)
                    vertices[numVertices - 1] shouldBe Vec3(x = 0.564511001f, y = 14.9660711f, z = 0.226483002)

                    normals[0] shouldBe Vec3(x = 0.738699973f, y = -0.110500000f, z = 0.664900005f)
                    normals[numVertices - 1] shouldBe Vec3(x = 0.956200004f, y = -0.109999999f, z = 0.271400005f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.153198004f, 0.172362998f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.491210997f, 0.944916010f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(7245, 7246, 7247)

                    materialIndex shouldBe 5

                    name shouldBe "Helmet"
                }

                with(meshes[6]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 8316
                    numFaces shouldBe 2772

                    vertices[0] shouldBe Vec3(x = 1.41331196f, y = 11.7699909f, z = -1.45877004f)
                    vertices[numVertices - 1] shouldBe Vec3(x = -0.137869999f, y = 13.8385210f, z = -1.14200103f)

                    normals[0] shouldBe Vec3(x = 0.990599990f, y = 0.0780000016f, z = -0.112599999f)
                    normals[numVertices - 1] shouldBe Vec3(x = 0.610899985f, y = 0.394199997f, z = -0.686600029f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.819335997f, 0.985771000f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.0746460035f, 0.579346001f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(8313, 8314, 8315)

                    materialIndex shouldBe 2

                    name shouldBe "Body"
                }

                with(materials[0]) {

                    name shouldBe "DefaultMaterial"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.600000024f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)   // TODO add transparent to other tests
                        refracti shouldBe 1f
                    }
                }

                with(materials[1]) {

                    name shouldBe "Arm"
                    shadingModel shouldBe AiShadingMode.phong

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.639999986f)
                        specular shouldBe Vec3(0.5f)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 96.0784302f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)
                        refracti shouldBe 1f
                    }

                    with(textures.find { it.type == AiTexture.Type.diffuse }!!) {
                        file shouldBe "arm_dif.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.ambient }!!) {
                        file shouldBe "arm_showroom_refl.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.specular }!!) {
                        file shouldBe "arm_showroom_spec.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.height }!!) {
                        file shouldBe "arm_showroom_ddn.png"
                        uvwsrc shouldBe 0
                    }
                }

                with(materials[2]) {

                    name shouldBe "Body"
                    shadingModel shouldBe AiShadingMode.phong

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.639999986f)
                        specular shouldBe Vec3(0.5f)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 96.0784302f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)
                        refracti shouldBe 1f
                    }

                    with(textures.find { it.type == AiTexture.Type.diffuse }!!) {
                        file shouldBe "body_dif.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.ambient }!!) {
                        file shouldBe "body_showroom_refl.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.specular }!!) {
                        file shouldBe "body_showroom_spec.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.height }!!) {
                        file shouldBe "body_showroom_ddn.png"
                        uvwsrc shouldBe 0
                    }
                }

                with(materials[3]) {

                    name shouldBe "Glass"
                    shadingModel shouldBe AiShadingMode.phong

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.639999986f)
                        specular shouldBe Vec3(0.5f)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 96.0784302f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)
                        refracti shouldBe 1f
                    }

                    with(textures.find { it.type == AiTexture.Type.diffuse }!!) {
                        file shouldBe "glass_dif.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.ambient }!!) {
                        file shouldBe "glass_refl.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.height }!!) {
                        file shouldBe "glass_ddn.png"
                        uvwsrc shouldBe 0
                    }
                }

                with(materials[4]) {

                    name shouldBe "Hand"
                    shadingModel shouldBe AiShadingMode.phong

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.639999986f)
                        specular shouldBe Vec3(0.5f)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 96.0784302f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)
                        refracti shouldBe 1f
                    }

                    with(textures.find { it.type == AiTexture.Type.diffuse }!!) {
                        file shouldBe "hand_dif.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.ambient }!!) {
                        file shouldBe "hand_showroom_refl.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.specular }!!) {
                        file shouldBe "hand_showroom_spec.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.height }!!) {
                        file shouldBe "hand_showroom_ddn.png"
                        uvwsrc shouldBe 0
                    }
                }

                with(materials[5]) {

                    name shouldBe "Helmet"
                    shadingModel shouldBe AiShadingMode.phong

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.639999986f)
                        specular shouldBe Vec3(0.5f)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 96.0784302f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)
                        refracti shouldBe 1f
                    }

                    with(textures.find { it.type == AiTexture.Type.diffuse }!!) {
                        file shouldBe "helmet_diff.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.ambient }!!) {
                        file shouldBe "helmet_showroom_refl.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.specular }!!) {
                        file shouldBe "helmet_showroom_spec.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.height }!!) {
                        file shouldBe "helmet_showroom_ddn.png"
                        uvwsrc shouldBe 0
                    }
                }

                with(materials[6]) {

                    name shouldBe "Leg"
                    shadingModel shouldBe AiShadingMode.phong

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.639999986f)
                        specular shouldBe Vec3(0.5f)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 96.0784302f
                        opacity shouldBe 1f
                        transparent shouldBe Vec3(1f)
                        refracti shouldBe 1f
                    }

                    with(textures.find { it.type == AiTexture.Type.diffuse }!!) {
                        file shouldBe "leg_dif.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.ambient }!!) {
                        file shouldBe "leg_showroom_refl.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.specular }!!) {
                        file shouldBe "leg_showroom_spec.png"
                        uvwsrc shouldBe 0
                    }
                    with(textures.find { it.type == AiTexture.Type.height }!!) {
                        file shouldBe "leg_showroom_ddn.png"
                        uvwsrc shouldBe 0
                    }
                }
            }
        }

        val spider = "spider.obj"

        spider {

            with(Importer().readFile(obj + spider)!!) {

                with(rootNode) {

                    name shouldBe "spider.obj"
                    transformation shouldBe Mat4()
                    numChildren shouldBe 19

                    val names = listOf("HLeib01", "OK", "Bein1Li", "Bein1Re", "Bein2Li", "Bein2Re", "Bein3Re", "Bein3Li", "Bein4Re",
                            "Bein4Li", "Zahn", "klZahn", "Kopf", "Brust", "Kopf2", "Zahn2", "klZahn2", "Auge", "Duplicate05")

                    (0 until numChildren).map {
                        children[it].name shouldBe names[it]
                        children[it].meshes[0] shouldBe it
                    }

                    numMeshes shouldBe 0
                }
                numMeshes shouldBe 19

                with(meshes[0]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 240
                    numFaces shouldBe 80

                    vertices[0] shouldBe Vec3(x = 1.160379, y = 4.512684, z = 6.449167)
                    vertices[numVertices - 1] shouldBe Vec3(x = -4.421391, y = -3.605049, z = -20.462471)

                    normals[0] shouldBe Vec3(-0.537588000, -0.0717979968, 0.840146005)
                    normals[numVertices - 1] shouldBe Vec3(-0.728103995, -0.400941998, -0.555975974)

                    // TODO check for kotlintest 2.0 array check
                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.186192f, 0.222718f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.103881f, 0.697021f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(237, 238, 239)

                    materialIndex shouldBe 3

                    name shouldBe "HLeib01"
                }
                with(meshes[1]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 180
                    numFaces shouldBe 60

                    vertices[0] shouldBe Vec3(x = -41.8566132f, y = -0.754845977f, z = 9.43077183f)
                    vertices[numVertices - 1] shouldBe Vec3(x = -49.7138367f, y = -2.98359, z = -21.4211159f)

                    normals[0] shouldBe Vec3(x = -0.236278996f, y = 0.0291850008f, z = 0.971247017f)
                    normals[numVertices - 1] shouldBe Vec3(x = -0.862017989f, y = 0.0830229968f, z = -0.500032008f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(-0.0658710003f, -0.410016000f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(-0.318565995f, 1.05051804f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(177, 178, 179)

                    materialIndex shouldBe 1

                    name shouldBe "OK"
                }
                with(meshes[18]) {

                    primitiveTypes shouldBe AiPrimitiveType.TRIANGLE.i
                    numVertices shouldBe 114
                    numFaces shouldBe 38

                    vertices[0] shouldBe Vec3(x = -59.4670486f, y = 18.1400757f, z = -17.1943588)
                    vertices[numVertices - 1] shouldBe Vec3(x = -62.2673569f, y = 15.2776031f, z = -14.7453232f)

                    normals[0] shouldBe Vec3(x = 0.0751359984f, y = 0.741809011f, z = -0.666388988f)
                    normals[numVertices - 1] shouldBe Vec3(x = -0.776385009f, y = -0.629855990f, z = 0.0225169994f)

                    Arrays.equals(textureCoords[0][0], floatArrayOf(0.899282992f, 0.970311999f)) shouldBe true
                    Arrays.equals(textureCoords[0][numVertices - 1], floatArrayOf(0.372330993f, 0.198948994f)) shouldBe true

                    textureCoords[0][0].size shouldBe 2

                    faces[0] shouldBe listOf(0, 1, 2)
                    faces[numFaces - 1] shouldBe listOf(111, 112, 113)

                    materialIndex shouldBe 5

                    name shouldBe "Duplicate05"
                }

                with(materials[0]) {

                    name shouldBe "DefaultMaterial"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0)
                        diffuse shouldBe Vec3(0.600000024f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                }
                with(materials[1]) {

                    name shouldBe "Skin"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0.200000003f)
                        diffuse shouldBe Vec3(0.827450991f, 0.792156994f, 0.772548974f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                    textures[0].file shouldBe ".\\wal67ar_small.jpg"
                }
                with(materials[2]) {

                    name shouldBe "Brusttex"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0.200000003f)
                        diffuse shouldBe Vec3(0.800000012f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                    textures[0].file shouldBe ".\\wal69ar_small.jpg"
                }
                with(materials[3]) {

                    name shouldBe "HLeibTex"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0.200000003f)
                        diffuse shouldBe Vec3(0.690195978f, 0.639216006f, 0.615685999f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                    textures[0].file shouldBe ".\\SpiderTex.jpg"
                }
                with(materials[4]) {

                    name shouldBe "BeinTex"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0.200000003f)
                        diffuse shouldBe Vec3(0.800000012f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                    textures[0].file shouldBe ".\\drkwood2.jpg"
                }
                with(materials[5]) {

                    name shouldBe "Augentex"
                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {
                        ambient shouldBe Vec3(0.200000003f)
                        diffuse shouldBe Vec3(0.800000012f)
                        specular shouldBe Vec3(0)
                        emissive shouldBe Vec3(0)
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                    textures[0].file shouldBe ".\\engineflare1.jpg"
                }
            }
        }

        val box = "box.obj"

        box {

            with(Importer().readFile(obj + box)!!) {

                with(rootNode) {

                    name shouldBe "box.obj"
                    transformation shouldBe Mat4()
                    numChildren shouldBe 1

                    with(children[0]) {

                        name shouldBe "1"
                        transformation shouldBe Mat4()
                        numChildren shouldBe 0
                        numMeshes shouldBe 1
                        meshes[0] shouldBe 0
                    }
                    numMeshes shouldBe 0
                }
                numMeshes shouldBe 1
                with(meshes[0]) {
                    primitiveTypes shouldBe AiPrimitiveType.POLYGON.i
                    numVertices shouldBe 24
                    numFaces shouldBe 6

                    vertices[0] shouldBe Vec3(-0.5, +0.5, +0.5)
                    vertices[5] shouldBe Vec3(+0.5, -0.5, -0.5)
                    vertices[10] shouldBe Vec3(+0.5, -0.5, -0.5)
                    vertices[15] shouldBe Vec3(-0.5, +0.5, +0.5)
                    vertices[20] shouldBe Vec3(+0.5, -0.5, -0.5)
                    vertices[23] shouldBe Vec3(+0.5, -0.5, +0.5)

                    var i = 0
                    faces.forEach {
                        it.size shouldBe 4
                        it shouldBe mutableListOf(i++, i++, i++, i++)
                    }
                }
                with(materials[0]) {
                    name shouldBe AI_DEFAULT_MATERIAL_NAME
                    shadingModel shouldBe AiShadingMode.gouraud
                    with(color!!) {
                        ambient shouldBe Vec3()
                        diffuse shouldBe Vec3(0.6)
                        specular shouldBe Vec3()
                        emissive shouldBe Vec3()
                        shininess shouldBe 0f
                        opacity shouldBe 1f
                        refracti shouldBe 1f
                    }
                }
            }
        }

        val concavePolygon = "concave_polygon.obj"

        concavePolygon {

            with(Importer().readFile(obj + concavePolygon)!!) {

                with(rootNode) {

                    name shouldBe "concave_polygon.obj"
                    transformation shouldBe Mat4()
                    numChildren shouldBe 2

                    with(children[0]) {

                        name shouldBe "concave_test.obj"
                        transformation shouldBe Mat4()
                        parent === rootNode
                        numChildren shouldBe 0
                        numMeshes shouldBe 0
                    }
                    with(children[1]) {

                        name shouldBe "default"
                        transformation shouldBe Mat4()
                        parent === rootNode
                        numChildren shouldBe 0
                        numMeshes shouldBe 1
                        meshes[0] shouldBe 0
                    }
                }
                with(meshes[0]) {

                    primitiveTypes shouldBe AiPrimitiveType.POLYGON.i
                    numVertices shouldBe 66
                    numFaces shouldBe 1

                    vertices[0] shouldBe Vec3(-1.14600003, 2.25515008, 3.07623005)
                    vertices[10] shouldBe Vec3(-1.14600003, 1.78262997, 1.93549001)
                    vertices[20] shouldBe Vec3(-1.14600003, 3.01736999, 1.93549001)
                    vertices[30] shouldBe Vec3(-1.14600003, 2.54485, 3.07623005)
                    vertices[40] shouldBe Vec3(-1.14600003, 3.08750010, 2.34999990)
                    vertices[50] shouldBe Vec3(-1.14600003, 2.13690996, 1.71483)
                    vertices[60] shouldBe Vec3(-1.14600003, 1.91386, 2.83613992)
                    vertices[65] shouldBe Vec3(-1.14600003, 2.40000010, 3.0905)

                    normals.forEach { it shouldBe Vec3(1, 0, -0.0) }
                    var i = 0
                    faces[0].forEach { it shouldBe i++ }

                    materialIndex shouldBe 1

                    name shouldBe "default"
                }
                numMaterials shouldBe 2

                with(materials[0]) {

                    name shouldBe "DefaultMaterial"

                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {

                        ambient!! shouldBe Vec3(0)
                        diffuse!! shouldBe Vec3(0.600000024)
                        specular!! shouldBe Vec3(0)
                        emissive!! shouldBe Vec3(0)
                        shininess!! shouldBe 0f
                        opacity!! shouldBe 1f
                        refracti!! shouldBe 1f
                    }
                }

                with(materials[1]) {

                    name shouldBe "test"

                    shadingModel shouldBe AiShadingMode.gouraud

                    with(color!!) {

                        ambient!! shouldBe Vec3(0)
                        diffuse!! shouldBe Vec3(0.141176000, 0.184313998, 0.411765009)
                        specular!! shouldBe Vec3(0)
                        emissive!! shouldBe Vec3(0)
                        shininess!! shouldBe 400f
                        opacity!! shouldBe 1f
                        refracti!! shouldBe 1f
                    }
                }
            }
        }
    }
}